varying mediump vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform mediump float process;
uniform mediump float ratio;

uniform mediump float baseScale;

mediump vec2 zoom(mediump vec2 uv, mediump float amount) {
    return 0.5 + ((uv - 0.5) * amount);
}

lowp float decelerate(lowp float x, lowp float factor) {
    return (1.0 - pow((1.0 - x), 2.0 * factor));
}

void main() {
    mediump vec2 baseTextureCoordinate = zoom(textureCoordinate, 1.0 / baseScale);
    mediump vec2 r = ((baseTextureCoordinate - vec2(0.5,0.5)) * vec2(1.0, 1.0 / ratio));
    mediump float pro = decelerate(process, 1.0);
    mediump float len = length(r);
    mediump vec2 uv = zoom(baseTextureCoordinate, 1.0 - 0.15 * pro);
    if (len < pro * 0.67) {
      mediump vec2 nextCoordination = zoom(textureCoordinate, 1.0 / (1.0 + process * (1.2 - 1.0)));
      gl_FragColor =  texture2D(inputImageTexture, textureCoordinate);
    }
    else if (len < pro * 0.65 *  1.5) {
      uv = zoom(uv, 1.0 - 0.15 * pro);
      gl_FragColor = texture2D(inputImageTexture, uv);
    }
    else {
        gl_FragColor = texture2D(inputImageTexture, uv);
    }
}