varying mediump vec2 textureCoordinate;

uniform sampler2D inputImageTexture; //显示层
uniform mediump float process;
uniform mediump float ratio;
uniform mediump float baseScale;

lowp float decelerate(lowp float x, lowp float factor) {
    return (1.0 - pow((1.0 - x), 2.0 * factor));
}

mediump vec2 zoom(mediump vec2 uv, mediump float amount) {
    return 0.5 + ((uv - 0.5) * amount);
}

void main() {
    mediump vec2 baseTextureCoordinate = zoom(textureCoordinate, 1.0 / baseScale);
    mediump float progress = decelerate(process, 1.2);
    mediump vec2 cood1 = (baseTextureCoordinate - vec2(0.5,0.5)) * (1.0 - process * 0.25) + vec2(0.5,0.5); // 放大
    if(
      ((ratio * (textureCoordinate.x - 0.5) + progress > (textureCoordinate.y - 0.5)) && (ratio * (textureCoordinate.x - 0.5) - progress < (textureCoordinate.y - 0.5)))
      ||
      (ratio * (textureCoordinate.x - 0.5) + 0.5 + ratio * 0.5 - progress < (textureCoordinate.y - 0.5))
      ||
      (ratio * (textureCoordinate.x - 0.5) - 0.5 - ratio * 0.5 + progress > (textureCoordinate.y - 0.5))
      ){
        //出现层
        mediump vec2 nextCoordination = zoom(textureCoordinate, 1.0 / (1.0 + process * (1.1 - 1.0)));
        gl_FragColor = texture2D(inputImageTexture, nextCoordination);
    } else {
        //消失层
        gl_FragColor = texture2D(inputImageTexture, cood1);
    }
}

