precision mediump float;

varying mediump vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform mediump vec2 singleStepOffset;
uniform mediump float uAlpha;

uniform mediump float process;

void main()
{
    vec2 blurCoordinates[24];
    blurCoordinates[0] = textureCoordinate.xy + singleStepOffset * vec2(0.0, -10.0);
    blurCoordinates[1] = textureCoordinate.xy + singleStepOffset * vec2(0.0, 10.0);
    blurCoordinates[2] = textureCoordinate.xy + singleStepOffset * vec2(-10.0, 0.0);
    blurCoordinates[3] = textureCoordinate.xy + singleStepOffset * vec2(10.0, 0.0);
    blurCoordinates[4] = textureCoordinate.xy + singleStepOffset * vec2(5.0, -8.0);
    blurCoordinates[5] = textureCoordinate.xy + singleStepOffset * vec2(5.0, 8.0);
    blurCoordinates[6] = textureCoordinate.xy + singleStepOffset * vec2(-5.0, 8.0);
    blurCoordinates[7] = textureCoordinate.xy + singleStepOffset * vec2(-5.0, -8.0);
    blurCoordinates[8] = textureCoordinate.xy + singleStepOffset * vec2(8.0, -5.0);
    blurCoordinates[9] = textureCoordinate.xy + singleStepOffset * vec2(8.0, 5.0);
    blurCoordinates[10] = textureCoordinate.xy + singleStepOffset * vec2(-8.0, 5.0);
    blurCoordinates[11] = textureCoordinate.xy + singleStepOffset * vec2(-8.0, -5.0);
    blurCoordinates[12] = textureCoordinate.xy + singleStepOffset * vec2(0.0, -6.0);
    blurCoordinates[13] = textureCoordinate.xy + singleStepOffset * vec2(0.0, 6.0);
    blurCoordinates[14] = textureCoordinate.xy + singleStepOffset * vec2(6.0, 0.0);
    blurCoordinates[15] = textureCoordinate.xy + singleStepOffset * vec2(-6.0, 0.0);
    blurCoordinates[16] = textureCoordinate.xy + singleStepOffset * vec2(-4.0, -4.0);
    blurCoordinates[17] = textureCoordinate.xy + singleStepOffset * vec2(-4.0, 4.0);
    blurCoordinates[18] = textureCoordinate.xy + singleStepOffset * vec2(4.0, -4.0);
    blurCoordinates[19] = textureCoordinate.xy + singleStepOffset * vec2(4.0, 4.0);
    blurCoordinates[20] = textureCoordinate.xy + singleStepOffset * vec2(-2.0, -2.0);
    blurCoordinates[21] = textureCoordinate.xy + singleStepOffset * vec2(-2.0, 2.0);
    blurCoordinates[22] = textureCoordinate.xy + singleStepOffset * vec2(2.0, -2.0);
    blurCoordinates[23] = textureCoordinate.xy + singleStepOffset * vec2(2.0, 2.0);

    vec4 blurColor = texture2D(inputImageTexture, textureCoordinate);
    blurColor += texture2D(inputImageTexture, blurCoordinates[0]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[1]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[2]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[3]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[4]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[5]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[6]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[7]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[8]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[9]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[10]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[11]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[12]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[13]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[14]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[15]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[16]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[17]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[18]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[19]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[20]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[21]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[22]);
    blurColor += texture2D(inputImageTexture, blurCoordinates[23]);

    blurColor = blurColor / 25.0;

    vec4 centralColor = texture2D(inputImageTexture, textureCoordinate);

    gl_FragColor = mix(blurColor, centralColor, process);
//
//    vec3 sum = vec3(0.0);
//    sum += texture2D(inputImageTexture, textureCoordinate - singleStepOffset * 4.0).rgb * 0.05;
//    sum += texture2D(inputImageTexture, textureCoordinate - singleStepOffset * 3.0).rgb * 0.09;
//    sum += texture2D(inputImageTexture, textureCoordinate - singleStepOffset * 2.0).rgb * 0.12;
//    sum += texture2D(inputImageTexture, textureCoordinate - singleStepOffset).rgb * 0.15;
//    sum += texture2D(inputImageTexture, textureCoordinate).rgb * 0.18;
//    sum += texture2D(inputImageTexture, textureCoordinate + singleStepOffset).rgb * 0.15;
//    sum += texture2D(inputImageTexture, textureCoordinate + singleStepOffset * 2.0).rgb * 0.12;
//    sum += texture2D(inputImageTexture, textureCoordinate + singleStepOffset * 3.0).rgb * 0.09;
//    sum += texture2D(inputImageTexture, textureCoordinate + singleStepOffset * 4.0).rgb * 0.05;
//    gl_FragColor = vec4(sum, uAlpha);
}