attribute vec4 position;
attribute vec4 inputTextureCoordinate;
uniform mat4 vMatrix;
uniform lowp float process;
varying vec2 textureCoordinate;

uniform lowp float startScale;
uniform lowp float endScale;
uniform lowp float startX;
uniform lowp float endX;
uniform lowp float startY;
uniform lowp float endY;


void main()
{

    lowp float scale = mix(startScale, endScale, process);
    lowp float transitionX = mix(startX, endX, process);
    lowp float transitionY = mix(startY, endY, process);
 
    mat4 trMatrix = mat4(
        scale, 0.0, transitionX, 0.0,
        0.0, scale, transitionY, 0.0,
        0.0, 0.0, 1.0, 0.0,
        0.0, 0.0, 0.0, 1.0
    );
    gl_Position = trMatrix *  vMatrix * position;
    textureCoordinate = inputTextureCoordinate.xy;
}