varying mediump vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform mediump float process;
uniform mediump float ratio;


mediump vec2 zoom(mediump vec2 uv, mediump float amount) {
    return 0.5 + ((uv - 0.5) * amount);
}

lowp float decelerate(lowp float x, lowp float factor) {
    return (1.0 - pow((1.0 - x), 2.0 * factor));
}

//void main() {
//    mediump vec2 r = 2.0 * ((textureCoordinate - vec2(0.5,0.5)) * vec2(1.0, 1.0 / ratio));
//    mediump float pro = decelerate(process, 1.0) / 0.2;
//    mediump float z = pro * 0.8;
//    mediump vec2 uv = textureCoordinate;
//    if (pro > 1.0) {
//      z = 0.8 + (pro - 1.0) * 0.3;
//    }
//    if (length(r) < z) {
//      // uv = zoom(uv, 0.9 - 0.1 * pro);
//      gl_FragColor =  vec4(0,0,0,0);
//    }
//    else if (length(r) < z*1.5) {
//      uv = zoom(uv, 1.0 - 0.15 * pro);
//      gl_FragColor = texture2D(inputImageTexture, uv);
//    }
//    else if (length(r) < 0.4+z*2.5) {
//      uv = zoom(uv, 1.0 - 0.2 * pro);
//      gl_FragColor = texture2D(inputImageTexture, uv);
//    }
//    else {
//        uv = zoom(uv, 1.0 - 0.25 * pro);
//        gl_FragColor = texture2D(inputImageTexture, uv);
//    }
//}

void main() {
    mediump vec2 r = ((textureCoordinate - vec2(0.5,0.5)) * vec2(1.0, 1.0 / ratio));
    mediump float pro = decelerate(process, 1.0);
    mediump float len = length(r);
    mediump vec2 uv = zoom(textureCoordinate, 0.864199 - 0.15 * pro);
    if (len < pro * 0.67) {
      // uv = zoom(uv, 0.9 - 0.1 * pro);
      gl_FragColor =  vec4(0,0,0,0);
//      gl_FragColor = vec4(1.0,0.0,0.0,1.0);
    }
    else if (len < pro * 0.65 *  1.5) {
      uv = zoom(uv, 1.0 - 0.15 * pro);
      gl_FragColor = texture2D(inputImageTexture, uv);
    }
    else {
        gl_FragColor = texture2D(inputImageTexture, uv);
    }
}

