varying mediump vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform mediump float process;
uniform mediump float ratio;

lowp float decelerate(lowp float x, lowp float factor) {
    return (1.0 - pow((1.0 - x), 2.0 * factor));
}

void main() {
    mediump float progress = decelerate(process, 1.2);
    mediump vec2 cood1 = (textureCoordinate - vec2(0.5,0.5)) * (1.0 - process * 0.15) + vec2(0.5,0.5); // 出现层
    mediump vec2 cood2 = (textureCoordinate - vec2(0.5,0.5)) * (0.6896 - process * 0.1) + vec2(0.5,0.5); // 消失层
    mediump float pro = progress / 2.0;
    if(
        (((-1.0 / pro) * (textureCoordinate.x - 0.5) + 0.5 > (textureCoordinate.y - 0.5)) && ((-1.0 / pro) * (textureCoordinate.x - 0.5) - 0.5 < (textureCoordinate.y - 0.5)))
        ||
        ((-1.0 / pro) * (textureCoordinate.x - 0.5) - 0.5 + (0.5 / pro) < (textureCoordinate.y - 0.5))
        ||
        ((-1.0 / pro) * (textureCoordinate.x - 0.5) + 0.5 - (0.5 / pro) > (textureCoordinate.y - 0.5))
      ){
      gl_FragColor = texture2D(inputImageTexture, cood1);
    } else {
      gl_FragColor =  texture2D(inputImageTexture2, cood2);
    }
}

//vec4 transition (vec2 uv) {
//  vec2 cood1 = (uv - vec2(0.5,0.5)) * (1.0 - progress * 0.15) + vec2(0.5,0.5);
//  vec2 cood2 = (uv - vec2(0.5,0.5)) * (0.7 + progress * 0.3) + vec2(0.5,0.5);
//  float pro = (0.5 + ratio * 0.6) * progress / 2.;  //maybe 0.6
//  pro = progress / 2.0;
//  if(
//    (((-1.0 / pro) * (uv.x - 0.5) + 0.5 > (uv.y - 0.5)) && ((-1.0 / pro) * (uv.x - 0.5) - 0.5 < (uv.y - 0.5)))
//    ||
//    ((-1.0 / pro) * (uv.x - 0.5) - 0.5 + (0.5 / pro) < (uv.y - 0.5))
//    ||
//    ((-1.0 / pro) * (uv.x - 0.5) + 0.5 - (0.5 / pro) > (uv.y - 0.5))
//    ){
//    return getFromColor(cood1);
//  } else {
//    return getFromColor(cood2);
//  }
//}

