precision mediump float;
uniform sampler2D inputImageTexture;
uniform sampler2D tex_hist;
uniform sampler2D tex_density;
uniform float scale;
uniform float shift_scale;
uniform float hist_offset;
uniform float hist_scale;
uniform float density_offset;
uniform float density_scale;
varying vec2 textureCoordinate;
void main() {
  const vec3 weights = vec3(0.33333, 0.33333, 0.33333);
  vec4 color = texture2D(inputImageTexture, textureCoordinate);
  float energy = dot(color.rgb, weights);
  float mask_value = energy - 0.5;
  float alpha;
  if (mask_value > 0.0) {
    alpha = (pow(2.0 * mask_value, 1.5) - 1.0) * scale + 1.0;
  } else {
    alpha = (pow(2.0 * mask_value, 2.0) - 1.0) * scale + 1.0;
  }
  float index = energy * hist_scale + hist_offset;
  vec4 temp = texture2D(tex_hist, vec2(index, 0.5));
  float value = temp.g + temp.r * shift_scale;
  index = value * density_scale + density_offset;
  temp = texture2D(tex_density, vec2(index, 0.5));
  value = temp.g + temp.r * shift_scale;
  float dst_energy = energy * alpha + value * (1.0 - alpha);
  float max_energy = energy / max(color.r, max(color.g, color.b));
  if (dst_energy > max_energy) {
    dst_energy = max_energy;
  }
  if (energy == 0.0) {
    gl_FragColor = color;
  } else {
    gl_FragColor = vec4(color.rgb * dst_energy / energy, color.a);
  }
}
