precision mediump float;
uniform sampler2D inputImageTexture;
uniform sampler2D noiseTexture;
uniform float scale;
uniform float stepX;
uniform float stepY;
varying vec2 textureCoordinate;

void main() {
   float noise = texture2D(noiseTexture, textureCoordinate + vec2(-stepX, -stepY)).r * 0.224;
   noise += texture2D(noiseTexture, textureCoordinate + vec2(-stepX, stepY)).r * 0.224;
   noise += texture2D(noiseTexture, textureCoordinate + vec2(stepX, -stepY)).r * 0.224;
   noise += texture2D(noiseTexture, textureCoordinate + vec2(stepX, stepY)).r * 0.224;
   noise += 0.4448;
   noise *= scale;
   vec4 color = texture2D(inputImageTexture, textureCoordinate);
   float energy = 0.33333 * color.r + 0.33333 * color.g + 0.33333 * color.b;
   float mask = (1.0 - sqrt(energy));
   float weight = 1.0 - 0.8 * mask * noise;
   gl_FragColor = vec4(color.rgb * weight, color.a);
}
