precision highp float;

uniform sampler2D inputImageTexture;

uniform vec2 singleStepOffset;

varying highp vec2 textureCoordinate;

const highp vec3 W = vec3(0.299,0.587,0.114);  //YUV 转换

float rgb2v(vec3 c) {
    return c.r > c.g ? (c.r > c.b ? c.r : c.b) : (c.g > c.b ? c.g : c.b);
}

vec4 floatToByte(float value) {
    vec4 res = vec4(0.0);
    float exponent = 0.0;
    float temp = abs(value);
    while(temp > 1.0) {
        temp = temp / 2.0;
        exponent++;
    }
    if(value < 0.0) {
        exponent += 128.0;
    }
    res.a = exponent / 255.0;
    temp = temp * 16777216.0;
    res.b = floor(mod(temp, 256.0)) / 255.0;
    temp = floor(temp / 256.0);
    res.g = floor(mod(temp, 256.0)) / 255.0;
    temp = floor(temp / 256.0);
    res.r = floor(mod(temp, 256.0)) / 255.0;
    return res;
}

//[[ 0.02039796  0.02040306  0.02040612  0.02040714  0.02040612  0.02040306 0.02039796]
// [ 0.02040306  0.02040816  0.02041122  0.02041224  0.02041122  0.02040816 0.02040306]
// [ 0.02040612  0.02041122  0.02041429  0.02041531  0.02041429  0.02041122 0.02040612]
// [ 0.02040714  0.02041224  0.02041531  0.02041633  0.02041531  0.02041224 0.02040714]
// [ 0.02040612  0.02041122  0.02041429  0.02041531  0.02041429  0.02041122 0.02040612]
// [ 0.02040306  0.02040816  0.02041122  0.02041224  0.02041122  0.02040816 0.02040306]
// [ 0.02039796  0.02040306  0.02040612  0.02040714  0.02040612  0.02040306 0.02039796]]


void main(){
    float gauessV = rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, -3.0)).rgb) * 0.02039796
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, -2.0)).rgb) * 0.02040306
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, -1.0)).rgb) * 0.02040612
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, 0.0)).rgb) * 0.02040714
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, 1.0)).rgb) * 0.02040612
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, 2.0)).rgb) * 0.02040306
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, 3.0)).rgb) * 0.02039796
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, -3.0)).rgb) * 0.02040306
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, -2.0)).rgb) * 0.02040816
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, -1.0)).rgb) * 0.02041122
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, 0.0)).rgb) * 0.02041224
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, 1.0)).rgb) * 0.02041122
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, 2.0)).rgb) * 0.02040816
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, 3.0)).rgb) * 0.02040306
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, -3.0)).rgb) * 0.02040612
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, -2.0)).rgb) * 0.02041122
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, -1.0)).rgb) * 0.02041429
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, 0.0)).rgb) * 0.02041531
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, 1.0)).rgb) * 0.02041429
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, 2.0)).rgb) * 0.02041122
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, 3.0)).rgb) * 0.02040612
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, -3.0)).rgb) * 0.02040714
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, -2.0)).rgb) * 0.02041224
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, -1.0)).rgb) * 0.02041531
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, 0.0)).rgb) * 0.02041633
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, 1.0)).rgb) * 0.02041531
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, 2.0)).rgb) * 0.02041224
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, 3.0)).rgb) * 0.02040714
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, -3.0)).rgb) * 0.02040612
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, -2.0)).rgb) * 0.02041122
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, -1.0)).rgb) * 0.02041429
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, 0.0)).rgb) * 0.02041531
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, 1.0)).rgb) * 0.02041429
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, 2.0)).rgb) * 0.02041122
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, 3.0)).rgb) * 0.02040612
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, -3.0)).rgb) * 0.02040306
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, -2.0)).rgb) * 0.02040816
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, -1.0)).rgb) * 0.02041122
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, 0.0)).rgb) * 0.02041224
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, 1.0)).rgb) * 0.02041122
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, 2.0)).rgb) * 0.02040816
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, 3.0)).rgb) * 0.02040306
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, -3.0)).rgb) * 0.02039796
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, -2.0)).rgb) * 0.02040306
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, -1.0)).rgb) * 0.02040612
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, 0.0)).rgb) * 0.02040714
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, 1.0)).rgb) * 0.02040612
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, 2.0)).rgb) * 0.02040306
                + rgb2v(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, 3.0)).rgb) * 0.02039796
                ;

      float sourceV = rgb2v(texture2D(inputImageTexture, textureCoordinate.xy).rgb);
      float retinex = log(sourceV * 255.0 + 1.0) / log(10.0) - log(gauessV * 255.0 + 1.0) / log(10.0);
      gl_FragColor = floatToByte(retinex);
}