precision mediump float;
uniform vec2 seed;
varying vec2 textureCoordinate;

float rand(vec2 loc) {
    float theta1 = dot(loc, vec2(0.9898, 0.233));
    float theta2 = dot(loc, vec2(12.0, 78.0));
    float value = cos(theta1) * sin(theta2) + sin(theta1) * cos(theta2);
    // keep value of part1 in range: (2^-14 to 2^14).
    float temp = mod(197.0 * value, 1.0) + value;
    float part1 = mod(220.0 * temp, 1.0) + temp;
    float part2 = value * 0.5453;
    float part3 = cos(theta1 + theta2) * 0.43758;
    return fract(part1 + part2 + part3);
}

void main() {
    gl_FragColor = vec4(rand(textureCoordinate + seed), 0.0, 0.0, 1.0);
}