precision highp float;

uniform sampler2D inputImageTexture;
uniform vec2 singleStepOffset;
uniform highp vec4 params;

varying highp vec2 textureCoordinate;

const highp vec3 W = vec3(0.299,0.587,0.114);  //YUV 转换
const mat3 saturateMatrix = mat3(
		1.1102,-0.0598,-0.061,
		-0.0774,1.0826,-0.1186,
		-0.0228,-0.0228,1.1772);

float hardlight(float color)
{
	if(color <= 0.5)
	{
		color = color * color * 2.0;
	}
	else
	{
		color = 1.0 - ((1.0 - color)*(1.0 - color) * 2.0);
	}
	return color;
}

void main(){
	vec3 centralColor = texture2D(inputImageTexture, textureCoordinate).rgb;

	float lumance = dot(centralColor, W);   //yuv 转换  Y 明度

    float alpha = pow(lumance, params.r);

	vec3 lvse = vec3(1.0)-(vec3(1.0)-centralColor)*(vec3(1.0)-centralColor);
	vec3 rouguang = 3.0*centralColor*centralColor - 2.0*centralColor*centralColor*centralColor;

	gl_FragColor = vec4(mix(centralColor, lvse, alpha), 1.0);
	gl_FragColor.rgb = mix(gl_FragColor.rgb, rouguang, params.b);

	vec3 satcolor = gl_FragColor.rgb * saturateMatrix;
	gl_FragColor.rgb = mix(gl_FragColor.rgb, satcolor, params.a);
}