varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D skinTexture;
uniform lowp float saturation;
uniform lowp float skinSaturation;

const mediump vec3 luminanceWeighting = vec3(0.2125, 0.7154, 0.0721);


void main()
{
    lowp float skinAlpha = texture2D(skinTexture, textureCoordinate).r;
    lowp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    lowp float luminance = dot(textureColor.rgb, luminanceWeighting);
    lowp vec3 greyScaleColor = vec3(luminance);
    if (skinAlpha > 0.5) {
        gl_FragColor = vec4(mix(greyScaleColor, textureColor.rgb, skinSaturation), textureColor.w);
    } else {
        gl_FragColor = vec4(mix(greyScaleColor, textureColor.rgb, saturation), textureColor.w);

    }
}
