precision highp float;

uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;


bool isSkin(vec3 color) {
    if ((color.r > 0.37109 && color.g > 0.15625 && color.b > 0.078125
                && color.r - color.b > 0.05859 && color.r - color.g > 0.05859)
                ||
                (color.r > 0.78125 && color.g > 0.8203125 && color.b > 0.6640625
                 && abs(color.r - color.b) <= 0.05859 && color.r > color.b
                 && color.g > color.b )) {
        return true;
    } else {
        return false;
    }
}


void main(){
    vec3 centralColor = texture2D(inputImageTexture, textureCoordinate).rgb;
    if (isSkin(centralColor)) {
        gl_FragColor = vec4(1.0,1.0,1.0,1.0);
    } else {
        gl_FragColor = vec4(0.0,0.0,0.0,1.0);
    }

}