attribute vec4 position;
attribute vec4 inputTextureCoordinate;
uniform mat4 vMatrix;
uniform lowp float process;
varying vec2 textureCoordinate;

uniform lowp float startScale;
uniform lowp float endScale;
uniform lowp float startX;
uniform lowp float endX;
uniform lowp float startY;
uniform lowp float endY;
uniform lowp float decelerate;
uniform lowp float accelerate;
uniform lowp float width;
uniform lowp float height;


void main()
{
	lowp float processCelerate = process;
    if (decelerate > 0.0) {
        processCelerate = (1.0 - pow((1.0 - process),  2.0 * decelerate));
    } else if (accelerate > 0.0) {
        processCelerate = pow(process,  2.0 * accelerate);
    }
    lowp float scale = mix(startScale, endScale, processCelerate);
    lowp float transitionX = mix(startX, endX, processCelerate) * width;
    lowp float transitionY = mix(startY, endY, processCelerate) * height;
 
    mat4 trMatrix = mat4(
        scale, 0.0, 0.0, 0.0,
        0.0, scale, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0,
        transitionX, transitionY, 0.0, 1.0
    );
    gl_Position = vMatrix * trMatrix * position;
    textureCoordinate = inputTextureCoordinate.xy;
}