#extension GL_OES_EGL_image_external : require
precision lowp float;

varying vec2 textureCoordinate;

uniform samplerExternalOES inputImageTexture;
uniform float uAlpha;

uniform vec2 singleStepOffset;

float getAlpha(vec2 coord) {
    vec4 color = texture2D(inputImageTexture, coord);
    if (color.r < 0.03 && color.g < 0.03 && color.b < 0.03 ) {
        return 0.0;
    } else {
        return 1.0;
    }
}

void main()
{
    vec4 thisColor = texture2D(inputImageTexture, textureCoordinate);
    float sum = getAlpha(textureCoordinate);
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(-1,-1));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(-1,0));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(-1,1));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(0,-1));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(0,1));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(1,-1));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(1,0));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(1,1));

    float sum1 = sum;
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(-2,-2));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(-2,0));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(-2,2));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(0,-2));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(0,2));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(2,-2));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(2,0));
    sum += getAlpha(textureCoordinate + singleStepOffset * vec2(2,2));

    sum1 = sum1 / 9.0;
    sum = sum / 17.0;
    if (sum1 < 0.9) {
        gl_FragColor.a = 0.0;
    } else {
        gl_FragColor.rgb = thisColor.rgb / sum;
        gl_FragColor.a = sum;
    }
}