precision lowp float;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;
uniform lowp float process;

lowp vec2 zoom(lowp vec2 uv, lowp float amount) {
  return 0.5 + ((uv - 0.5) * (1.0-amount));
}

lowp float decelerate(lowp float x, lowp float factor) {
    return (1.0 - pow((1.0 - x), 2.0 * factor));
}

void main() {
    lowp float pp = mod(process, 0.25) * 4.0;
    lowp vec2 zoomCoor = zoom(textureCoordinate, process*0.18);
    lowp vec4 color = texture2D(inputImageTexture, zoomCoor);
    lowp float deceleratePP = decelerate(pp, 1.4);
    lowp vec2 zoomCoorR = zoom(zoomCoor, deceleratePP * 0.1);
    lowp vec2 zoomCoorG = zoom(zoomCoor, deceleratePP * 0.2);

    lowp vec4 shadowR = texture2D(inputImageTexture, zoomCoorR);
    lowp vec4 shadowG = texture2D(inputImageTexture, zoomCoorG);

//    lowp vec2 coor = (textureCoordinate - vec2(0.5,0.5))*(1.0-process*0.2);
//    lowp vec2 zoomCoor = coor + vec2(0.5,0.5);
//    lowp vec4 color = texture2D(inputImageTexture, zoomCoor);
//
//    lowp vec2 zoomCoorR = coor + vec2(0.5-pp/16.0, 0.5-pp/16.0);
//    lowp vec2 zoomCoorG = coor + vec2(0.5+pp/16.0, 0.5+pp/16.0);
//
//    lowp vec4 shadowR = texture2D(inputImageTexture, zoomCoorR);
//    lowp vec4 shadowG = texture2D(inputImageTexture, zoomCoorG);

    color = color * (0.6 + 0.6 * pp) + shadowR * (0.2 - 0.2 * pp) + shadowG * (0.2 - 0.2 * pp);
    gl_FragColor = color;
}